Index: code/trunk/src/bullet/BulletCollision/Gimpact/gim_box_set.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/Gimpact/gim_box_set.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/Gimpact/gim_box_set.cpp	(revision 2882)
@@ -111,6 +111,5 @@
 	}
 
-	bool unbal = (splitIndex==startIndex) || (splitIndex == (endIndex));
-	btAssert(!unbal);
+	btAssert(!((splitIndex==startIndex) || (splitIndex == (endIndex))));
 
 	return splitIndex;
@@ -181,2 +180,3 @@
 }
 
+
Index: code/trunk/src/bullet/BulletCollision/Gimpact/gim_math.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/Gimpact/gim_math.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/Gimpact/gim_math.h	(revision 2882)
@@ -108,5 +108,5 @@
 #define GIM_CLAMP(number,minval,maxval) (number<minval?minval:(number>maxval?maxval:number))
 
-#define GIM_GREATER(x, y)	fabsf(x) > (y)
+#define GIM_GREATER(x, y)	btFabs(x) > (y)
 
 ///Swap numbers
Index: code/trunk/src/bullet/BulletCollision/Gimpact/gim_tri_collision.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/Gimpact/gim_tri_collision.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/Gimpact/gim_tri_collision.h	(revision 2882)
@@ -276,5 +276,5 @@
 		else
 		{
-			float sumuv;
+			btScalar sumuv;
 			sumuv = u+v;
 			if(sumuv<-G_EPSILON)
Index: code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btContinuousConvexCollision.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btContinuousConvexCollision.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btContinuousConvexCollision.cpp	(revision 2882)
@@ -136,4 +136,7 @@
 			//btScalar clippedDist  = dist;
 			
+			//don't report time of impact for motion away from the contact normal (or causes minor penetration)
+			if ((projectedLinearVelocity+ maxAngularProjectedVelocity)<=SIMD_EPSILON)
+				return false;
 			
 			dLambda = dist / (projectedLinearVelocity+ maxAngularProjectedVelocity);
@@ -197,9 +200,8 @@
 
 		}
-
-		//don't report time of impact for motion away from the contact normal (or causes minor penetration)
+	
 		if ((projectedLinearVelocity+ maxAngularProjectedVelocity)<=result.m_allowedPenetration)//SIMD_EPSILON)
 			return false;
-
+			
 		result.m_fraction = lambda;
 		result.m_normal = n;
Index: code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btGjkPairDetector.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btGjkPairDetector.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btGjkPairDetector.cpp	(revision 2882)
@@ -151,5 +151,6 @@
 			if ((delta > btScalar(0.0)) && (delta * delta > squaredDistance * input.m_maximumDistanceSquared)) 
 			{
-				checkPenetration = false;
+				checkSimplex=true;
+				//checkPenetration = false;
 				break;
 			}
Index: code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btManifoldPoint.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btManifoldPoint.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btManifoldPoint.h	(revision 2882)
@@ -113,4 +113,10 @@
 			}
 			
+			///this returns the most recent applied impulse, to satisfy contact constraints by the constraint solver
+			btScalar	getAppliedImpulse() const
+			{
+				return m_appliedImpulse;
+			}
+
 			
 
Index: code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btPersistentManifold.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btPersistentManifold.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btPersistentManifold.cpp	(revision 2882)
@@ -184,4 +184,7 @@
 		
 	}
+	if (insertIndex<0)
+		insertIndex=0;
+
 	btAssert(m_pointCache[insertIndex].m_userPersistentData==0);
 	m_pointCache[insertIndex] = newPoint;
Index: code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btPersistentManifold.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btPersistentManifold.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btPersistentManifold.h	(revision 2882)
@@ -56,4 +56,5 @@
 
 	btScalar	m_contactBreakingThreshold;
+	btScalar	m_contactProcessingThreshold;
 
 	
@@ -71,7 +72,8 @@
 	btPersistentManifold();
 
-	btPersistentManifold(void* body0,void* body1,int , btScalar contactBreakingThreshold)
+	btPersistentManifold(void* body0,void* body1,int , btScalar contactBreakingThreshold,btScalar contactProcessingThreshold)
 		: m_body0(body0),m_body1(body1),m_cachedPoints(0),
-		m_contactBreakingThreshold(contactBreakingThreshold)
+		m_contactBreakingThreshold(contactBreakingThreshold),
+		m_contactProcessingThreshold(contactProcessingThreshold)
 	{
 		
@@ -112,4 +114,9 @@
 	///@todo: get this margin from the current physics / collision environment
 	btScalar	getContactBreakingThreshold() const;
+
+	btScalar	getContactProcessingThreshold() const
+	{
+		return m_contactProcessingThreshold;
+	}
 	
 	int getCacheEntry(const btManifoldPoint& newPoint) const;
Index: code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btRaycastCallback.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btRaycastCallback.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btRaycastCallback.cpp	(revision 2882)
@@ -24,8 +24,10 @@
 #include "btRaycastCallback.h"
 
-btTriangleRaycastCallback::btTriangleRaycastCallback(const btVector3& from,const btVector3& to)
+btTriangleRaycastCallback::btTriangleRaycastCallback(const btVector3& from,const btVector3& to, unsigned int flags)
 	:
 	m_from(from),
 	m_to(to),
+   //@BP Mod
+   m_flags(flags),
 	m_hitFraction(btScalar(1.))
 {
@@ -56,4 +58,10 @@
 		return ; // same sign
 	}
+   //@BP Mod - Backface filtering
+   if (((m_flags & kF_FilterBackfaces) != 0) && (dist_a > btScalar(0.0)))
+   {
+      // Backface, skip check
+      return;
+   }
 	
 	const btScalar proj_length=dist_a-dist_b;
@@ -90,12 +98,16 @@
 					if ( (btScalar)(cp2.dot(triangleNormal)) >=edge_tolerance) 
 					{
+                  //@BP Mod
+                  // Triangle normal isn't normalized
+				      triangleNormal.normalize();
 
-						if ( dist_a > 0 )
+                  //@BP Mod - Allow for unflipped normal when raycasting against backfaces
+                  if (((m_flags & kF_KeepUnflippedNormal) != 0) || (dist_a <= btScalar(0.0)))
 						{
-							m_hitFraction = reportHit(triangleNormal,distance,partId,triangleIndex);
+							m_hitFraction = reportHit(-triangleNormal,distance,partId,triangleIndex);
 						}
 						else
 						{
-							m_hitFraction = reportHit(-triangleNormal,distance,partId,triangleIndex);
+                     m_hitFraction = reportHit(triangleNormal,distance,partId,triangleIndex);
 						}
 					}
Index: code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btRaycastCallback.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btRaycastCallback.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btRaycastCallback.h	(revision 2882)
@@ -30,7 +30,18 @@
 	btVector3 m_to;
 
+   //@BP Mod - allow backface filtering and unflipped normals
+   enum EFlags
+   {
+      kF_None                 = 0,
+      kF_FilterBackfaces      = 1 << 0,
+      kF_KeepUnflippedNormal  = 1 << 1,   // Prevents returned face normal getting flipped when a ray hits a back-facing triangle
+
+      kF_Terminator        = 0xFFFFFFFF
+   };
+   unsigned int m_flags;
+
 	btScalar	m_hitFraction;
 
-	btTriangleRaycastCallback(const btVector3& from,const btVector3& to);
+	btTriangleRaycastCallback(const btVector3& from,const btVector3& to, unsigned int flags=0);
 	
 	virtual void processTriangle(btVector3* triangle, int partId, int triangleIndex);
Index: code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btVoronoiSimplexSolver.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btVoronoiSimplexSolver.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/NarrowPhaseCollision/btVoronoiSimplexSolver.cpp	(revision 2882)
@@ -26,6 +26,4 @@
 
 #include "btVoronoiSimplexSolver.h"
-#include <assert.h>
-//#include <stdio.h>
 
 #define VERTA  0
@@ -38,5 +36,5 @@
 {
 	
-	assert(m_numVertices>0);
+	btAssert(m_numVertices>0);
 	m_numVertices--;
 	m_simplexVectorW[index] = m_simplexVectorW[m_numVertices];
Index: code/trunk/src/bullet/BulletDynamics/CMakeLists.txt
===================================================================
--- code/trunk/src/bullet/BulletDynamics/CMakeLists.txt	(revision 2881)
+++ code/trunk/src/bullet/BulletDynamics/CMakeLists.txt	(revision 2882)
@@ -36,4 +36,5 @@
 	ConstraintSolver/btTypedConstraint.h
 
+	Dynamics/btActionInterface.h
 	Dynamics/btContinuousDynamicsWorld.h
 	Dynamics/btDiscreteDynamicsWorld.h
Index: code/trunk/src/bullet/BulletDynamics/Character/btCharacterControllerInterface.h
===================================================================
--- code/trunk/src/bullet/BulletDynamics/Character/btCharacterControllerInterface.h	(revision 2881)
+++ code/trunk/src/bullet/BulletDynamics/Character/btCharacterControllerInterface.h	(revision 2882)
@@ -18,4 +18,5 @@
 
 #include "LinearMath/btVector3.h"
+#include "BulletDynamics/Dynamics/btActionInterface.h"
 
 class btCollisionShape;
@@ -23,5 +24,5 @@
 class btCollisionWorld;
 
-class btCharacterControllerInterface
+class btCharacterControllerInterface : public btActionInterface
 {
 public:
Index: code/trunk/src/bullet/BulletDynamics/Character/btKinematicCharacterController.cpp
===================================================================
--- code/trunk/src/bullet/BulletDynamics/Character/btKinematicCharacterController.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletDynamics/Character/btKinematicCharacterController.cpp	(revision 2882)
@@ -23,4 +23,6 @@
 #include "btKinematicCharacterController.h"
 
+static btVector3 upAxisDirection[3] = { btVector3(1.0f, 0.0f, 0.0f), btVector3(0.0f, 1.0f, 0.0f), btVector3(0.0f, 0.0f, 1.0f) };
+
 ///@todo Interact with dynamic objects,
 ///Ride kinematicly animated platforms properly
@@ -94,6 +96,7 @@
 }
 
-btKinematicCharacterController::btKinematicCharacterController (btPairCachingGhostObject* ghostObject,btConvexShape* convexShape,btScalar stepHeight)
-{
+btKinematicCharacterController::btKinematicCharacterController (btPairCachingGhostObject* ghostObject,btConvexShape* convexShape,btScalar stepHeight, int upAxis)
+{
+	m_upAxis = upAxis;
 	m_addedMargin = 0.02f;
 	m_walkDirection.setValue(0,0,0);
@@ -102,6 +105,5 @@
 	m_stepHeight = stepHeight;
 	m_turnAngle = btScalar(0.0);
-	m_convexShape=convexShape;
-	
+	m_convexShape=convexShape;	
 }
 
@@ -110,5 +112,4 @@
 }
 
-
 btPairCachingGhostObject* btKinematicCharacterController::getGhostObject()
 {
@@ -116,5 +117,5 @@
 }
 
-bool btKinematicCharacterController::recoverFromPenetration (btCollisionWorld* collisionWorld)
+bool btKinematicCharacterController::recoverFromPenetration ( btCollisionWorld* collisionWorld)
 {
 
@@ -173,5 +174,5 @@
 	// phase 1: up
 	btTransform start, end;
-	m_targetPosition = m_currentPosition + btVector3 (btScalar(0.0), m_stepHeight, btScalar(0.0));
+	m_targetPosition = m_currentPosition + upAxisDirection[m_upAxis] * m_stepHeight;
 
 	start.setIdentity ();
@@ -179,5 +180,5 @@
 
 	/* FIXME: Handle penetration properly */
-	start.setOrigin (m_currentPosition + btVector3(btScalar(0.0), btScalar(0.1), btScalar(0.0)));
+	start.setOrigin (m_currentPosition + upAxisDirection[m_upAxis] * btScalar(0.1f));
 	end.setOrigin (m_targetPosition);
 
@@ -344,6 +345,6 @@
 
 	// phase 3: down
-	btVector3 step_drop = btVector3(btScalar(0.0), m_currentStepOffset, btScalar(0.0));
-	btVector3 gravity_drop = btVector3(btScalar(0.0), m_stepHeight, btScalar(0.0));
+	btVector3 step_drop = upAxisDirection[m_upAxis] * m_currentStepOffset;
+	btVector3 gravity_drop = upAxisDirection[m_upAxis] * m_stepHeight; 
 	m_targetPosition -= (step_drop + gravity_drop);
 
@@ -390,5 +391,5 @@
 
 
-void btKinematicCharacterController::preStep ( btCollisionWorld* collisionWorld)
+void btKinematicCharacterController::preStep (  btCollisionWorld* collisionWorld)
 {
 	
@@ -413,5 +414,5 @@
 }
 
-void btKinematicCharacterController::playerStep ( btCollisionWorld* collisionWorld, btScalar dt)
+void btKinematicCharacterController::playerStep (  btCollisionWorld* collisionWorld, btScalar dt)
 {
 	btTransform xform;
@@ -469,2 +470,7 @@
 	return true;
 }
+
+
+void	btKinematicCharacterController::debugDraw(btIDebugDraw* debugDrawer)
+{
+}
Index: code/trunk/src/bullet/BulletDynamics/Character/btKinematicCharacterController.h
===================================================================
--- code/trunk/src/bullet/BulletDynamics/Character/btKinematicCharacterController.h	(revision 2881)
+++ code/trunk/src/bullet/BulletDynamics/Character/btKinematicCharacterController.h	(revision 2882)
@@ -63,4 +63,6 @@
 
 	bool	m_useGhostObjectSweepTest;
+
+	int m_upAxis;
 	
 	btVector3 computeReflectionDirection (const btVector3& direction, const btVector3& normal);
@@ -68,5 +70,5 @@
 	btVector3 perpindicularComponent (const btVector3& direction, const btVector3& normal);
 
-	bool recoverFromPenetration (btCollisionWorld* collisionWorld);
+	bool recoverFromPenetration ( btCollisionWorld* collisionWorld);
 	void stepUp (btCollisionWorld* collisionWorld);
 	void updateTargetPositionBasedOnCollision (const btVector3& hit_normal, btScalar tangentMag = btScalar(0.0), btScalar normalMag = btScalar(1.0));
@@ -74,7 +76,27 @@
 	void stepDown (btCollisionWorld* collisionWorld, btScalar dt);
 public:
-	btKinematicCharacterController (btPairCachingGhostObject* ghostObject,btConvexShape* convexShape,btScalar stepHeight);
+	btKinematicCharacterController (btPairCachingGhostObject* ghostObject,btConvexShape* convexShape,btScalar stepHeight, int upAxis = 1);
 	~btKinematicCharacterController ();
 	
+
+	///btActionInterface interface
+	virtual void updateAction( btCollisionWorld* collisionWorld,btScalar deltaTime)
+	{
+		preStep ( collisionWorld);
+		playerStep (collisionWorld, deltaTime);
+	}
+	
+	///btActionInterface interface
+	void	debugDraw(btIDebugDraw* debugDrawer);
+
+	void setUpAxis (int axis)
+	{
+		if (axis < 0)
+			axis = 0;
+		if (axis > 2)
+			axis = 2;
+		m_upAxis = axis;
+	}
+
 	virtual void	setWalkDirection(const btVector3& walkDirection)
 	{
@@ -85,6 +107,6 @@
 	void warp (const btVector3& origin);
 
-	void preStep ( btCollisionWorld* collisionWorld);
-	void playerStep (btCollisionWorld* collisionWorld, btScalar dt);
+	void preStep (  btCollisionWorld* collisionWorld);
+	void playerStep ( btCollisionWorld* collisionWorld, btScalar dt);
 
 	void setFallSpeed (btScalar fallSpeed);
